<?php

/**
 * Add function to widgets_init that'll load our widget.
 * @since 0.1
 */
add_action( 'widgets_init', function(){ register_widget( 'IMWB_CGT_Widget' );} );

/**
 * IMWB CGT Widget.
 * This class handles everything that needs to be handled with the widget:
 * the settings, form, display, and update.
 *
 * @since 0.1
 */
class IMWB_CGT_Widget extends WP_Widget {

	/**
	 * Widget setup.
	 */
	function __construct() {

		/* Widget settings. */
		$widget_ops = array( 'classname' => 'imwb_cgt_widget', 'description' => 'Display your Widget Ads' );

		/* Create the widget. */
		parent::__construct( 'imwb_cgt_widget', 'IMWB CGT Widget', $widget_ops);
	}

	/**
	 * How to display the widget on the screen.
	 */
	function widget( $args, $instance ) {
   	global $IMWBCovertGeoTargeterPRO;

		extract( $args );
    $title = isset($instance['title']) ? $instance['title'] : '';
		/* Our variables from the widget settings. */
		$title = apply_filters('widget_title', $title  );

		/* Before widget (defined by themes). */
		echo $before_widget;

		/* Display the widget title if one was input (before and after defined by themes). */
		if ( $title )
			echo $before_title . $title . $after_title;

		echo '<div class="textwidget">'.$IMWBCovertGeoTargeterPRO->get_widget_ad_variation($instance['wad_id']).'</div>';

		/* After widget (defined by themes). */
		echo $after_widget;
	}

	/**
	 * Update the widget settings.
	 */
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* No need to strip tags for sex and show_sex. */
		$instance['wad_id'] = $new_instance['wad_id'];

		return $instance;
	}

	/**
	 * Displays the widget settings controls on the widget panel.
	 * Make use of the get_field_id() and get_field_name() function
	 * when creating your form elements. This handles the confusing stuff.
	 */
	function form( $instance ) {
      global $wpdb;

		/* Set up some default widget settings. */
		$defaults = array('wad_id' => '0');
		$instance = wp_parse_args( (array) $instance, $defaults );
?>
		<p>
			<label for="<?php echo $this->get_field_id( 'wad_id' ); ?>">Select Widget Ad To Show:</label>
			<select id="<?php echo $this->get_field_id( 'wad_id' ); ?>" name="<?php echo $this->get_field_name( 'wad_id' ); ?>" class="widefat" style="width:100%;">
<?php
   $widgetAds = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}imwb_cgt_widget_ad ORDER BY name" );
   foreach ($widgetAds as $widgetAd)
    echo "<option value='{$widgetAd->wad_id}' ".($instance['wad_id'] == $widgetAd->wad_id ? "selected" : "").">{$widgetAd->name}</option>";
?>
			</select>
		</p>
	<?php
	}
}

?>
