<?php
/*
Plugin Name: Covert Geo Targeter PRO
Description: Powerful yet simple to use geo targeting plugin that lets you serve different ads for different countries, maximizing your profits. You can create both widget and in-post ads with this plugin.
Version: 2.1
Author: IM Wealth Builders Ltd
Author URI: http://imwealthbuilders.com/newplugins

Copyright 2019  IM Wealth Builders

*/

define('IMWB_CGT_PRO_VERSION', '2.1');
define('IMWB_CGT_PRO_FOLDER', 'covertgeotargeter-pro');
define('IMWB_CGT_PRO_PREFIX', 'imwb_');
define('IMWB_CGT_PRO_FILE', __FILE__ );

/**
 * This is where you add comments for your plugin class
 * @author John Merrick
 */
class IMWB_Covert_Geo_Targeter_PRO {
	/**
	 * This value will be used for
	 * - the gettext textdomain
	 * - the subfolder when adding scripts and styles
	 * - the handle for scripts and styles
	 * Please make sure that this value corresponds to the folder name where your plugin resides.
	 * @var string
	 */
	 var $plugin_name = "";
	 var $plugin_url = "";
	 var $update;
	 var $geolocation;
	 var $options = Array();
    var $countryList = Array("XX" => "All Countries","AU" => "Australia","CA" => "Canada", "IE" => "Ireland","GB" => "United Kingdom","US" => "United States","NZ" => "New Zealand","AT" => "Austria","BE" => "Belgium","BG" => "Bulgaria","CY" => "Cyprus","CZ" => "Czech Republic","DK" => "Denmark","EE" => "Estonia","FI" => "Finland","FR" => "France","DE" => "Germany","GR" => "Greece","HU" => "Hungary","IT" => "Italy","LV" => "Latvia","LT" => "Lithuania","LU" => "Luxembourg","MT" => "Malta","NL" => "Netherlands","PL" => "Poland","PT" => "Portugal","RO" => "Romania","SK" => "Slovakia","SI" => "Slovenia","ES" => "Spain","SE" => "Sweden","AF" => "Afghanistan","AX" => "&Aring;land Islands","AL" => "Albania","DZ" => "Algeria","AS" => "American Samoa","AD" => "Andorra","AO" => "Angola","AI" => "Anguilla","AQ" => "Antarctica","AG" => "Antigua and Barbuda","AR" => "Argentina","AM" => "Armenia","AW" => "Aruba","AZ" => "Azerbaijan","BS" => "Bahamas","BH" => "Bahrain","BD" => "Bangladesh","BB" => "Barbados","BY" => "Belarus","BZ" => "Belize","BJ" => "Benin","BM" => "Bermuda","BT" => "Bhutan","BO" => "Bolivia, Plurinational State of","BA" => "Bosnia and Herzegovina","BW" => "Botswana","BV" => "Bouvet Island","BR" => "Brazil","IO" => "British Indian Ocean Territory","BN" => "Brunei Darussalam","BF" => "Burkina Faso","BI" => "Burundi","KH" => "Cambodia","CM" => "Cameroon","CV" => "Cape Verde","KY" => "Cayman Islands","CF" => "Central African Republic","TD" => "Chad","CL" => "Chile","CN" => "China","CX" => "Christmas Island","CC" => "Cocos (Keeling) Islands","CO" => "Colombia","KM" => "Comoros","CG" => "Congo","CD" => "Congo, the Democratic Republic of the","CK" => "Cook Islands","CR" => "Costa Rica","CI" => "C&ocirc;te d'Ivoire","HR" => "Croatia","CU" => "Cuba","DJ" => "Djibouti","DM" => "Dominica","DO" => "Dominican Republic","EC" => "Ecuador","EG" => "Egypt","SV" => "El Salvador","GQ" => "Equatorial Guinea","ER" => "Eritrea","ET" => "Ethiopia","FK" => "Falkland Islands (Malvinas)","FO" => "Faroe Islands","FJ" => "Fiji","GF" => "French Guiana","PF" => "French Polynesia","TF" => "French Southern Territories","GA" => "Gabon","GM" => "Gambia","GE" => "Georgia","GH" => "Ghana","GI" => "Gibraltar","GL" => "Greenland","GD" => "Grenada","GP" => "Guadeloupe","GU" => "Guam","GT" => "Guatemala","GG" => "Guernsey","GN" => "Guinea","GW" => "Guinea-Bissau","GY" => "Guyana","HT" => "Haiti","HM" => "Heard Island and McDonald Islands","VA" => "Holy See (Vatican City State)","HN" => "Honduras","HK" => "Hong Kong","IS" => "Iceland","IN" => "India","ID" => "Indonesia","IR" => "Iran, Islamic Republic of","IQ" => "Iraq","IM" => "Isle of Man","IL" => "Israel","JM" => "Jamaica","JP" => "Japan","JE" => "Jersey","JO" => "Jordan","KZ" => "Kazakhstan","KE" => "Kenya","KI" => "Kiribati","KP" => "Korea, Democratic People's Republic of","KR" => "Korea, Republic of","KW" => "Kuwait","KG" => "Kyrgyzstan","LA" => "Lao People's Democratic Republic","LB" => "Lebanon","LS" => "Lesotho","LR" => "Liberia","LY" => "Libyan Arab Jamahiriya","LI" => "Liechtenstein","MO" => "Macao","MK" => "Macedonia, the former Yugoslav Republic of","MG" => "Madagascar","MW" => "Malawi","MY" => "Malaysia","MV" => "Maldives","ML" => "Mali","MH" => "Marshall Islands","MQ" => "Martinique","MR" => "Mauritania","MU" => "Mauritius","YT" => "Mayotte","MX" => "Mexico","FM" => "Micronesia, Federated States of","MD" => "Moldova, Republic of","MC" => "Monaco","MN" => "Mongolia","ME" => "Montenegro","MS" => "Montserrat","MA" => "Morocco","MZ" => "Mozambique","MM" => "Myanmar","NA" => "Namibia","NR" => "Nauru","NP" => "Nepal","AN" => "Netherlands Antilles","NC" => "New Caledonia","NI" => "Nicaragua","NE" => "Niger","NG" => "Nigeria","NU" => "Niue","NF" => "Norfolk Island","MP" => "Northern Mariana Islands","NO" => "Norway","OM" => "Oman","PK" => "Pakistan","PW" => "Palau","PS" => "Palestinian Territory, Occupied","PA" => "Panama","PG" => "Papua New Guinea","PY" => "Paraguay","PE" => "Peru","PH" => "Philippines","PN" => "Pitcairn","PR" => "Puerto Rico","QA" => "Qatar","RE" => "R&eacute;union","RU" => "Russian Federation","RW" => "Rwanda","BL" => "Saint Barth&eacute;lemy","SH" => "Saint Helena, Ascension and Tristan da Cunha","KN" => "Saint Kitts and Nevis","LC" => "Saint Lucia","MF" => "Saint Martin (French part)","PM" => "Saint Pierre and Miquelon","VC" => "Saint Vincent and the Grenadines","WS" => "Samoa","SM" => "San Marino","ST" => "Sao Tome and Principe","SA" => "Saudi Arabia","SN" => "Senegal","RS" => "Serbia","SC" => "Seychelles","SL" => "Sierra Leone","SG" => "Singapore","SB" => "Solomon Islands","SO" => "Somalia","ZA" => "South Africa", "GS" => "South Georgia and the South Sandwich Islands","LK" => "Sri Lanka","SD" => "Sudan","SR" => "Suriname","SJ" => "Svalbard and Jan Mayen","SZ" => "Swaziland","CH" => "Switzerland","SY" => "Syrian Arab Republic","TW" => "Taiwan, Province of China","TJ" => "Tajikistan","TZ" => "Tanzania, United Republic of","TH" => "Thailand","TL" => "Timor-Leste","TG" => "Togo","TK" => "Tokelau","TO" => "Tonga","TT" => "Trinidad and Tobago","TN" => "Tunisia","TR" => "Turkey","TM" => "Turkmenistan","TC" => "Turks and Caicos Islands","TV" => "Tuvalu","UG" => "Uganda","UA" => "Ukraine","AE" => "United Arab Emirates","UM" => "United States Minor Outlying Islands","UY" => "Uruguay","UZ" => "Uzbekistan","VU" => "Vanuatu","VE" => "Venezuela, Bolivarian Republic of","VN" => "Viet Nam","VG" => "Virgin Islands, British","VI" => "Virgin Islands, U.S.","WF" => "Wallis and Futuna","EH" => "Western Sahara","YE" => "Yemen","ZM" => "Zambia","ZW" => "Zimbabwe");

	/**
	 * The constructor is executed when the class is instatiated and the plugin gets loaded.
	 * @return void
	 */
	function __construct() {

	   $this->plugin_name = IMWB_CGT_PRO_PREFIX.IMWB_CGT_PRO_FOLDER;

   	// Hack to avoid firing on Admin Login or Registration page
   	if ( in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) )
   	   return;

   	$this->plugin_url = plugins_url(basename( dirname( __FILE__)));

    $this->options = $this->get_admin_options();

    if(is_admin()){
         // Get Update Information
      	$this->get_update_info();
      	add_action('admin_notices', array(&$this, 'admin_warnings'));
      	add_action('wp_ajax_'.$this->plugin_name.'_clear_cookie', array(&$this, 'clear_cookie'));
   	    add_action('admin_init', array(&$this,'init_admin'));
      	add_action('admin_menu', array(&$this,'init_admin_menu'));
      }
      else {
         $this->geolocation = $this->get_geo_location();

      	add_filter('the_title', array(&$this, 'populate_geo_location'), '1');
      	add_filter('widget_text', array(&$this, 'populate_geo_location'), '1');
      	add_filter('widget_title', array(&$this, 'populate_geo_location'), '1');
      	add_filter('wp_title', array(&$this, 'populate_geo_location'), '1');
      	add_filter('the_content', array(&$this, 'insert_ad'), '10');
      	add_filter('option_blogdescription', array(&$this, 'populate_geo_location'), '1');
      	add_filter('option_blogname', array(&$this, 'populate_geo_location'), '1');

      	add_shortcode( 'imwb_cgt_countryCode', array(&$this, 'countryCode_shortcode_handler') );
      	add_shortcode( 'imwb_cgt_countryName', array(&$this, 'countryName_shortcode_handler') );
      	add_shortcode( 'imwb_cgt_regionName', array(&$this, 'regionName_shortcode_handler') );
      	add_shortcode( 'imwb_cgt_cityName', array(&$this, 'cityName_shortcode_handler') );
      	add_shortcode( 'imwb_cgt_ad', array(&$this, 'postAd_shortcode_handler') );
      }

	}

		/**
		 * This function is executed when the plugin is activated.
		 * @return void
		 */
		static function install_db() {
		    global $wpdb;

			/**
			 * This value represent the current version of the layout of the database tables. This value
			 * needs to be increased every time you change something in your database layout.
			 * @var integer
			 */
			$db_version = 1;

		    /**
		     * To create tables, dbDelta from wp-admin/includes/upgrade.php is needed
		     */
		    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

	       $current_version = null;
	       $current_version = get_option('imwb_covertgeotargeter-pro-db-version',0);

		    // Check if the latest version is already installed
		    if($current_version == $db_version) {
		    	return;
		    }

		    // Define tables
		    $tables = array('imwb_cgt_widget_ad', 'imwb_cgt_widget_ad_var', 'imwb_cgt_post_ad', 'imwb_cgt_post_ad_var');
		    $structure = array(

		       "(`wad_id` int(11) NOT NULL AUTO_INCREMENT,
		         `name` varchar(100) NOT NULL,
		         PRIMARY KEY (`wad_id`) ) ENGINE=MyISAM AUTO_INCREMENT=1",

		       "(`wav_id` int(11) NOT NULL AUTO_INCREMENT,
		         `wad_id` int(11) NOT NULL,
		         `countries` text NOT NULL,
		         `ad_code` longtext NOT NULL,
		         PRIMARY KEY (`wav_id`) ) ENGINE=MyISAM AUTO_INCREMENT=1",

             "(`pad_id` int(11) NOT NULL AUTO_INCREMENT,
               `name` varchar(100) NOT NULL,
               `insert_type` char(1) NOT NULL DEFAULT 'S',
               `align` char(1) NOT NULL DEFAULT 'L',
               `pos` char(1) NOT NULL DEFAULT 'T',
               `margin` int(11) NOT NULL,
               `where_shown` text NOT NULL,
               PRIMARY KEY (`pad_id`) ) ENGINE=MyISAM AUTO_INCREMENT=1",

             "(`pav_id` int(11) NOT NULL AUTO_INCREMENT,
               `pad_id` int(11) NOT NULL,
               `width` int(11) NOT NULL,
               `height` int(11) NOT NULL,
               `countries` text NOT NULL,
               `ad_code` longtext NOT NULL,
               PRIMARY KEY (`pav_id`) ) ENGINE=MyISAM AUTO_INCREMENT=1"
			 );

			 // Upgrade routine from DB version 1
			 $upgrade = Array();
		//	 $upgrade[1] = array("imwb_cab_settings" => "ALTER TABLE %simwb_cab_settings ADD `bar_reshow_days` smallint(6) NOT NULL default 0, ADD `bar_reshow_hours` smallint(6) NOT NULL default 0, ADD `play_sound` tinyint(3)  NOT NULL default 1");

			// Iterate tables and create them
			foreach ($tables as $key => $table) {
				if($wpdb->get_var(sprintf("SHOW TABLES LIKE '%s%s'", $wpdb->prefix, $table)) != $wpdb->prefix . $table) {
					// Table doesn't exist, create it.
					$sql = sprintf("CREATE TABLE %s%s %s DEFAULT CHARSET=utf8", $wpdb->prefix, $table, $structure[$key]);
					dbDelta($sql);
				} else {
					// Table exists, check if there's any upgrade routines defined.
					// The upgrade routines are applied in order from previous to current version

					for ($i = $current_version; $i < $db_version; $i++) {
						if (strlen($upgrade[ $i ][ $table ]) > 0) {
							$sql = sprintf($upgrade[ $i ][ $table ], $wpdb->prefix);
							$wpdb->query($sql);
						}
					}
				}
		   }

	   	if ($current_version === false) {
	   		add_option('imwb_covertgeotargeter-pro-db-version', $db_version);
	   	} else {
	   		update_option('imwb_covertgeotargeter-pro-db-version', $db_version);
	   	}
	   }

	function admin_warnings() {

		 if(empty($this->options['api_key']) && !isset($_POST['submit']) ) {
				echo "<div id='update-nag' class='update-nag'><strong>Covert Geo Targeter PRO is almost ready</strong> ".sprintf(__('You must <a href="%1$s">enter your API key</a> for it to work.'), "options-general.php?page=imwb_covertgeotargeter-pro-admin-menu")."</div>";
			}
	}

	//Returns an array of admin options
	function get_admin_options() {
		$adminOptions = array('provider' => 'I',
		                      'api_key' => '',
		                      'def_ctycode' => '',
		                      'def_ctyname' => '',
		                      'def_regname' => '',
		                      'def_cityname'=>'');

		$devOptions = get_option("imwb_covertgeotargeter-AdminOptions");
		if (!empty($devOptions)) {
			foreach ($devOptions as $key => $option)
				$adminOptions[$key] = $option;
		}
		update_option("imwb_covertgeotargeter-AdminOptions", $adminOptions);
		return $adminOptions;
	}

	/**
	 * Register the admin option page stylesheet and scripts
	 */
	function init_admin() {

	   wp_register_style($this->plugin_name . '-page-stylesheet', $this->plugin_url.'/styles/admin_options_page.css');
	   wp_register_script($this->plugin_name . '-script', $this->plugin_url.'/scripts/admin_options_page.js');
	   wp_register_script($this->plugin_name . '-reports-script', $this->plugin_url.'/scripts/admin_reports_page.js');

	}

   /*
    * Will only be called on our plugin admin page, enqueue our stylesheet here
    */
   function load_admin_styles() {
       wp_enqueue_style($this->plugin_name . '-page-stylesheet');
   }

   /**
    * Loading the Admin side scripts
    * @return void
    */
   function load_admin_scripts() {

   	// Only enqueue scripts on frontend.
   	wp_enqueue_script('jquery');

      wp_enqueue_script('imwb_cgt_admin_options_script', $this->plugin_url.'/scripts/admin_options_page.js', array('jquery'), '1.1');

   	wp_localize_script('imwb_cgt_admin_options_script', 'IMWB_CGT_Ajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce' => wp_create_nonce( 'imwb_cgt_clear_cookie_nonce' ), 'plugin_url' => $this->plugin_url, 'wp_root' => $this->get_wp_root_path() ) );
   }

	/**
	 * Adds a new menu with the name "My Admin Menu" and let's anyone that
	 * can publish posts be able to use it.
	 * @return void
	 */
  function init_admin_menu() {
    // Add the menu page
    $hook_name = add_menu_page( 'Covert Geo Targeter PRO Admin Menu',
        'Covert Geo Targeter PRO',
        'manage_options',
        $this->plugin_name . '-admin-menu',
        array(&$this, 'load_settings_page'),
      'dashicons-location-alt');

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'Covert Geo Targeter PRO Settings', 'Settings', 'manage_options', $this->plugin_name . '-admin-menu', array(&$this, 'load_settings_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'Covert Geo Targeter Widget Ads', 'Widget Ads', 'manage_options', $this->plugin_name . '-widget_ads', array(&$this, 'loads_widget_ads_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'Covert Geo Targeter Post/Page Ads', 'Post/Page Ads', 'manage_options', $this->plugin_name . '-post_ads', array(&$this, 'loads_post_ads_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page(null, '', '', 'manage_options', $this->plugin_name . '-create_widget_ad', array(&$this, 'load_create_widget_ad_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page(null, '', '', 'manage_options', $this->plugin_name . '-widget_ad_var_list', array(&$this, 'load_widget_ad_var_list_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page(null, '', '', 'manage_options', $this->plugin_name . '-create_widget_ad_var', array(&$this, 'load_widget_ad_var_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page(null, '', '', 'manage_options', $this->plugin_name . '-create_post_ad', array(&$this, 'load_create_post_ad_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));

    $hook_name = add_submenu_page(null, '', '', 'manage_options', $this->plugin_name . '-create_post_ad_var', array(&$this, 'load_post_ad_var_page'));

    add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
    add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));
	}

	/**
	 * This function will be executed when the admin settings page is to be loaded
	 * @return void
	 */
	function load_settings_page() {

		// Include the HTML from a separate file to keep the plugin class clean
		require "pages/admin_options_page.php";
	}

	/**
	 * This function will be executed when the widgets page is to be loaded
	 * @return void
	 */
	function loads_widget_ads_page() {

		// Include the HTML from a separate file to keep the plugin class clean
		require "pages/admin_widgets_page.php";
	}

	/**
	 * This function will be executed when the post/page page is to be loaded
	 * @return void
	 */
	function loads_post_ads_page() {

		// Include the HTML from a separate file to keep the plugin class clean
		require "pages/admin_post_page.php";
	}


	/**
	 * This function will be executed when the a widgets ad page is to be loaded
	 * @return void
	 */
	function load_create_widget_ad_page() {

		// Include the HTML from a separate file to keep the plugin class clean
		require "pages/create_widget_ad_page.php";
	}

   /**
    * This function will be executed when the a widgets ad page is to be loaded
    * @return void
    */
   function	load_create_post_ad_page() {

   	// Include the HTML from a separate file to keep the plugin class clean
   	require "pages/create_post_ad_page.php";
   }

   /**
    * This function will be executed when the widgets ad variations list page is to be loaded
    * @return void
    */
   function load_widget_ad_var_list_page() {

   		// Include the HTML from a separate file to keep the plugin class clean
   		require "pages/widget_ad_vars_list.php";
   }

   /**
    * This function will be executed when the widgets ad variations page is to be loaded
    * @return void
    */
   function load_widget_ad_var_page() {

   		// Include the HTML from a separate file to keep the plugin class clean
   		require "pages/create_widget_ad_var.php";
   }

   /**
    * This function will be executed when the post/page ad variations page is to be loaded
    * @return void
    */
   function load_post_ad_var_page() {

   		// Include the HTML from a separate file to keep the plugin class clean
   		require "pages/create_post_ad_var.php";
   }

	function get_wp_root_path()
	{
	    $path = parse_url(get_bloginfo('wpurl'), PHP_URL_PATH);
	    if(!isset($path))
	       return '/';
	    else
	  	    return $path;
	}

	function get_update_info() {
      // Include Update Class
      require_once('DigitalGuard_IT_Updater_1_0.php');

      // Initialize Update Object
      $this->update = new DigitalGuard_IT_Updater_1_0('5234538F29CBE', IMWB_CGT_PRO_FILE, IMWB_CGT_PRO_FOLDER, 'plugin-update');
	}

	function populate_geo_location($content) {

	   $content = str_ireplace('[imwb_cgt_countryCode]',$this->countryCode_shortcode_handler(), $content);
  	   $content = str_ireplace('[imwb_cgt_countryName]',$this->countryName_shortcode_handler(), $content);
  	   $content = str_ireplace('[imwb_cgt_regionName]',$this->regionName_shortcode_handler(), $content);
  	   $content = str_ireplace('[imwb_cgt_cityName]',$this->cityName_shortcode_handler(), $content);

	   return $content;
	}

	function countryCode_shortcode_handler() {
	   if(empty($this->geolocation->countryCode))
	      return $this->options['def_ctycode'];

   	return $this->geolocation->countryCode;
	}

   function countryName_shortcode_handler() {
      if(empty($this->geolocation->countryName))
         return $this->options['def_ctyname'];

   	return ucwords(strtolower($this->geolocation->countryName));
   }

   function regionName_shortcode_handler() {
      if(empty($this->geolocation->regionName))
         return $this->options['def_regname'];

   	return ucwords(strtolower($this->geolocation->regionName));
   }

   function cityName_shortcode_handler() {
      if(empty($this->geolocation->cityName))
         return $this->options['def_cityname'];

   	return ucwords(strtolower($this->geolocation->cityName));
   }

   function postAd_shortcode_handler ($att) {

      $adVar = $this->get_post_ad_variation($att['id']);
      if(is_array($adVar))
         return $adVar['ad_code'];

      return '';
   }


	function get_geo_location(){

    if ( !empty( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} elseif ( !empty ( $_SERVER['HTTP_X_REAL_IP'] ) ) {
			$ip = $_SERVER['HTTP_X_REAL_IP'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}

// $ip = "31.153.25.147"; //CY
// $ip = "86.3.27.75"; //UK
// $ip = "24.154.228.129"; // USA

      // Check if "cache" cookie is set
      if(isset($_COOKIE['imwb_cgt_loc'])) {
	      $result = unserialize(stripslashes(base64_decode($_COOKIE['imwb_cgt_loc'])));
         if($result->ipAddress == $ip && $result->provider == $this->options['provider'])
	         return $result;
	   }

      if($this->options['provider'] == 'I')
	       return $this->ipinfodb_get_geo_location($ip);
	    else
	       return $this->geoplugin_get_geo_location($ip);
	}

	function ipinfodb_get_geo_location($ip) {

    if(empty($this->options['api_key']))
     return false;

    $answer = wp_remote_get("http://api.ipinfodb.com/v3/ip-city/?key=".$this->options['api_key']."&ip=$ip&format=json", array(
      'timeout' => 60,
      'user-agent' => 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36'
    ));

    if(is_wp_error($answer) || 200 != $answer['response']['code'])
    {
      //wp_die('Could not get Country information.','Covert Geo Targeter Error');
      // MIGHT WANT TO SET DEFAULTS.
      return false;
    }

    $answer = json_decode($answer['body']);

    // Convert UK to GB (ISO Std is GB)
    if($answer->countryCode == 'UK')
      $answer->countryCode = 'GB';

    $result = new stdClass();
    $result->provider = "I";
    $result->ipAddress = $answer->ipAddress;
    $result->countryCode = $answer->countryCode;
    $result->countryName = $answer->countryName;
    $result->regionName = $answer->regionName == '-' ? '' : $answer->regionName;
    $result->cityName = $answer->cityName == '-' ? '' : $answer->cityName;

    setcookie('imwb_cgt_loc',base64_encode(serialize($result)),time()+60*60,COOKIEPATH);

    return $result;
	}

   function geoplugin_get_geo_location($ip){

     require_once('geoplugin.class.php');

     $geoplugin = new IMWB_CGT_PRO_geoPlugin();

     $geoplugin->locate($ip);
//
// echo "Geolocation results for {$geoplugin->ip}: <br />\n".
// 	"City: {$geoplugin->city} <br />\n".
// 	"Region: {$geoplugin->region} <br />\n".
// 	"Region Code: {$geoplugin->regionCode} <br />\n".
// 	"Region Name: {$geoplugin->regionName} <br />\n".
// 	"DMA Code: {$geoplugin->dmaCode} <br />\n".
// 	"Country Name: {$geoplugin->countryName} <br />\n".
// 	"Country Code: {$geoplugin->countryCode} <br />\n".
// 	"In the EU?: {$geoplugin->inEU} <br />\n".
// 	"EU VAT Rate: {$geoplugin->euVATrate} <br />\n".
// 	"Latitude: {$geoplugin->latitude} <br />\n".
// 	"Longitude: {$geoplugin->longitude} <br />\n".
// 	"Radius of Accuracy (Miles): {$geoplugin->locationAccuracyRadius} <br />\n".
// 	"Timezone: {$geoplugin->timezone}  <br />\n".
// 	"Currency Code: {$geoplugin->currencyCode} <br />\n".
// 	"Currency Symbol: {$geoplugin->currencySymbol} <br />\n".
// 	"Exchange Rate: {$geoplugin->currencyConverter} <br />\n";

    $result = new stdClass();
    $result->provider = "G";
    $result->ipAddress = $geoplugin->ip;
    $result->countryCode = $geoplugin->countryCode;
    $result->countryName = $geoplugin->countryName;
    $result->regionName = $geoplugin->regionName;
    $result->cityName = $geoplugin->city;

   		setcookie('imwb_cgt_loc',base64_encode(serialize($result)),time()+60*60,COOKIEPATH);
   	    return $result;
   }

	function sanitize_text($text) {

	   $text = do_shortcode($text);
//	   $text = preg_replace("/(\r\n|\r|\n)/", "<br>", $text);
	   $text = stripslashes($text);

	   return $text;
	}

	/*
	 * Returns the ad code variation for the passed widget id
	 * current geo location is used to filter the ads
	 */
	function get_widget_ad_variation($wad_id) {
	   global $wpdb;

	   $widgetAdVars = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}imwb_cgt_widget_ad_var WHERE wad_id = {$wad_id} ORDER BY wav_id" );
	   foreach ($widgetAdVars as $widgetAdVar) {

	      $selCountries = explode(',', $widgetAdVar->countries);

	      // Check for ALL Countries Set or Current Country code set
	      if(in_array('XX', $selCountries) || in_array($this->geolocation->countryCode, $selCountries))
	         return $this->sanitize_text($widgetAdVar->ad_code);
	   }

	   return '';
	}

	/*
	 * Returns the ad code variation for the passed post ad id
	 * current geo location is used to filter the ads
	 */
	function get_post_ad_variation($pad_id) {
	   global $wpdb;

	   $postAdVars = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}imwb_cgt_post_ad_var WHERE pad_id = {$pad_id} ORDER BY pav_id" );
	   foreach ($postAdVars as $postAdVar) {
	      $selCountries = explode(',', $postAdVar->countries);

	      // Check for ALL Countries Set or Current Country code set
	      if(in_array('XX', $selCountries) || in_array($this->geolocation->countryCode, $selCountries))
	         return array("pav_id" => $postAdVar->pav_id, "width" => $postAdVar->width, "height" => $postAdVar->height, "ad_code" => $this->sanitize_text($postAdVar->ad_code));
	   }

	   return NULL;
	}

   /**
    * Inserts any available ads in the post/page
    * @return true/false
    */
   function	insert_ad($content) {
      global $wpdb;
      $imwb_db_post_ad_table_name = $wpdb->prefix."imwb_cgt_post_ad";
      $imwb_db_post_ad_var_table_name = $wpdb->prefix."imwb_cgt_post_ad_var";

      if(is_front_page())
         return $content;

      // See if any ads set to show
      $found = false;
      $postAds = $wpdb->get_results( "SELECT * FROM $imwb_db_post_ad_table_name WHERE insert_type = 'A' ORDER BY name" );
      foreach ($postAds as $postAd) {
         $postAd->where_shown = unserialize($postAd->where_shown);
         if($this->can_show($postAd->where_shown)) {  // See if we can show it
            $ad_code = $this->get_post_ad_variation($postAd->pad_id);
            if(is_array($ad_code))
              $found = true;
         }

         if($found)
            break;
      }

      if($found) {
         $width = '';
         $margin = '';
         $height = '';

         // Build the ad code
         if($postAd->margin > 0)
            $margin = ";margin: {$postAd->margin}px";

         if($postAd->align == "L")
            $align = "float: left";
         else if($postAd->align == "C") {
            if($postAd->margin > 0)
               $align = "padding: {$postAd->margin}px";
               $margin = ";margin: 0px auto";
         }
         else
            $align = "float: right";

         if($ad_code['width'] > 0)
            $width = ";width: {$ad_code['width']}px";

         if($ad_code['height'] > 0)
            $height = ";height: {$ad_code['height']}px";

         $adBlock = "<div class='imwb_cgt_ad_block' style='{$align}{$margin}{$width}{$height}'>{$ad_code['ad_code']}</div>";

         if($postAd->pos == "E")
            $content = $content.$adBlock;
         else
            $content = $adBlock.$content;
      }

      return $content;
   }

	/**
	 * Checks if an ad can be shown according to the passed in settings
	 * @return true/false
	 */
	function can_show($adSettings) {
	   global $wp_query;

	   $adPageIds = explode(',', $adSettings['postid']);

	   if(is_page() &&  $adSettings['Pages'] == 'G')
	      return true;

	   // If we are on a page then see if set to display
	   if(is_page() && is_array($adSettings['pageid']) && in_array($wp_query->post->ID,$adSettings['pageid']))
	      return true;

      if(is_single() && $adSettings['Posts'] == 'P')
	      return true;

	   // If we are on a page then check if we are set to display for this specific post
	   if(is_single() && in_array($wp_query->post->ID,$adPageIds))
	      return true;

	   // Were on a page so see if set to display for this category
	   if(is_single()) {
	      $postCats = get_the_category();
	      foreach($postCats as $cat) {
	         if(is_array($adSettings['catid']) && in_array($cat->cat_ID,$adSettings['catid']))
	         return true;
	      }
	   }

	   // Get here then no set to display
	   return false;
	}
}

/**
 * Register the plugin
 */
$IMWBCovertGeoTargeterPRO = null;

function run_covert_geo_targeter_pro() {
  global $IMWBCovertGeoTargeterPRO;
	$IMWBCovertGeoTargeterPRO = new IMWB_Covert_Geo_Targeter_PRO();
}
run_covert_geo_targeter_pro();

function covert_geo_targeter_pro_activation_func() {
  IMWB_Covert_Geo_Targeter_PRO::install_db();
}
register_activation_hook( __FILE__, 'covert_geo_targeter_pro_activation_func' );

function imwb_cgtp_admin_notice(){

   $plugin_file = 'covertgeotargeter/covertgeotargeter-plugin.php';

   if (is_plugin_active($plugin_file)) {
         echo "<div id='update-nag' class='update-nag'><strong>Covert Geo Targeter PRO</strong> You must deactivate the standard version of Covert Geo Targeter</div>";
   }
}

add_action('admin_notices', 'imwb_cgtp_admin_notice');

require_once('cgt_widget.php');
